/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdlib.h>
#include <gba.h>
#include "basic_types_defs.h"
#include "game.h"
#include "automaton.h"
#include "printing.h"



DAGElement *automaton = NULL ;
unsigned long automaton_size = 0 ;
unsigned long initial_state = END_TRANSITION ;

const unsigned long french_dic_mapped_memory[]
  __attribute__ ((section (".rodata"))) =
{
  /* 0x4d444943 : M D I C */
#include "data/raw_french_dic_data"
} ;



const unsigned long english_dic_mapped_memory[]
  __attribute__ ((section (".rodata"))) =
{
  /* 0x4d444943 : M D I C */
#include "data/raw_english_dic_data"
} ;





BOOL load_dictionary (enum language language)
{
  const unsigned long *dic_mapped_memory = NULL ;

  switch (language) {
  case Lang_French: dic_mapped_memory = french_dic_mapped_memory ; break ;
  case Lang_English: dic_mapped_memory = english_dic_mapped_memory ; break ;
  default:
    popup_message (FALSE, "load_dictionary\nASSERT 0") ;
    return (FALSE) ;
    break ;
  }

  /* Check magic word. */
  if (dic_mapped_memory[0] != TABLEMAGICNUMBER) return (FALSE) ;

  /* Check automaton size. */
  automaton_size = dic_mapped_memory[1] ;
  if (automaton_size == 0) return (FALSE) ;

  // Get the initial state
  initial_state = dic_mapped_memory[2] ;

  // Assign the global pointer of the automaton to the mapped memory.
  automaton = (DAGElement*) &dic_mapped_memory[3] ;
  return (TRUE) ;
}
