/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#ifndef __GAME_H__
#define __GAME_H__

#define NB_LETTERS 7

typedef unsigned char String_letter ;
typedef String_letter* String ;
typedef unsigned char Letter ;

struct list_item {
  String item ;
  struct list_item *next ;
  struct list_item *prev ;
} ;


enum language { Lang_French = 0, Lang_English = 1 } ;

enum game_status { Game_over, Game_attempt, Game_extra, Game_level_complete } ;

#define MAX_DISPLAYED_SUBMISSIONS 20
#define MIN_PERCENT 50
#define MIN_LEN (1 * 7 + 2 * 6 + 3 * 5 + 4 * 3 + 5 * 3) /* 61 */
#define BASE_AVAILABLE_SECONDS (3 * 60)
#define MIN_AVAILABLE_SECONDS 20

struct game {
  enum game_status game_status ;
  short level ;
  short min_length_to_win ;
  short available_time ;

  Letter letters_backup[NB_LETTERS] ;
  Letter letters[NB_LETTERS] ;
  short nb_letters_left ;
  short nb_possibilities ;
  short total_possibilities_length ;
  struct list_item *possibilities ;

  String_letter submission[NB_LETTERS + 1] ;
  struct list_item *submissions_head ;
  struct list_item *submissions_tail ;
  short nb_found ;
  short total_found_length ;
  short progress_percent ;

  struct list_item *display[MAX_DISPLAYED_SUBMISSIONS] ;

  unsigned long score ;
} ;


extern struct game global_game ;
extern unsigned long global_hall_of_fame[5] ;

struct game* start_game (unsigned long, short) ;
BOOL try_add_letter_to_submission (struct game*, short) ;
BOOL try_remove_letter_from_submission (struct game*) ;

enum submission_result {
  Already_Sumbitted, Non_Existing, Too_Short, Correct, Level_successful,
  Level_fully_complete } ;

enum submission_result process_user_submission (struct game*) ;
void shuffle_letters (struct game*) ;
BOOL update_high_scores (struct game*) ;

#endif
