/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <gba.h>
#include <screen_mode.h>
#include "basic_types_defs.h"
#include "game_over_data.h"
#include "gfx_effects.h"
#include "messages.h"
#include "printing.h"
#include "intro.h"




void init_game_over ()
{
  u16 old_screen_mode ;
  u16 i, j, k ;
  u16 *bg_pal = BACKGROUND_PALETTE_ADDR ;
  u16 *bg_tiles = CHAR_BASE_BLOCK_0_ADDR ;
  u16 *bg_map = SCREEN_BASE_BLOCK_24_ADDR ;


  old_screen_mode = REG_DISPCNT ;
  set_screen_mode (0) ;

    /* Fond. */
  set_background0
    (BACKGROUND_PRIORITY_3 |            /* Priorit la plus faible. */
     BACKGROUND_CHAR_BASE_BLOCK_0 |     /* Tiles */
     BACKGROUND_COLOR_256 |             /* 256 couleurs. */
     BACKGROUND_SCREEN_BASE_BLOCK_24 |  /* Map. */
     TEXT_BACKGROUND_256x256) ;         /* 256 x 256 pixels. */

  /* Palette du fond. */
  for (i = 0; i < GAME_OVER_PALETTE_SIZE; i++)
    bg_pal[i] = game_over_palette[i] ;

  /* Chargement des tiles du fond d'cran en mmoire. */
  k = 0 ;
  for (i = 0; i < GAME_OVER_NB_TILES * (64 / 2); i++) {
    bg_tiles[k] =
      (u16) ((game_over_tiles[(i * 2) + 1]<< 8) |
	     (game_over_tiles[(i * 2)])) ;
    k++ ;
  }

  /* Chargement de la map de fond. */
  k = 0 ;
  for (j = 0; j < 20; j++) {          /* Boucle verticale. */
    for (i = 0; i < 30; i++) {        /* Boucle honrizontale. */
      bg_map[(j * (256 / 8)) + i] = (u16) game_over_map[0] ;
      k++ ;
    }
  }

  REG_BG0HOFS = 0 ; REG_BG0VOFS = 0 ;
  set_screen_mode (MODE_0 | BG0_ENABLE) ;
  horizontal_slide_screen ((u16*) game_over_map, (u16*) bg_map,
			   GAME_OVER_MAP_TOP_OFFSET, GAME_OVER_MAP_HEIGHT) ;
  blink_key_sprite () ;
  set_screen_mode (old_screen_mode) ;
}
