/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdlib.h>
#include <string.h>
#include <gba.h>
#include <screen_mode.h>
#include <interrupt.h>
#include "basic_types_defs.h"
#include "init.h"
#include "key_input.h"
#include "gfx_effects.h"
#include "interrupts.h"


void shake_and_blink_screen ()
{
  u16 old_blending_mode ;
  short i ;

  old_blending_mode = REG_BLDMOD ;
  REG_COLEY = 0 ;
  set_blending_mode (FADE_MODE_2 | FADE_SOURCE_BG1) ;
  for (i = 0; i < 16; i++) {
    while (REG_VCOUNT != 160) ;
    REG_COLEY = (u16) i ;
    REG_BG0HOFS = ((s16) ((rand ()) % 8)) - 4 ;
    REG_BG0VOFS = ((s16) ((rand ()) % 8)) - 4 ;
  }
  for (i = 15; i >= 0; i--) {
    while (REG_VCOUNT != 160) ;
    REG_COLEY = (u16) i ;
    REG_BG0HOFS = ((s16) ((rand ()) % 8)) - 4 ;
    REG_BG0VOFS = ((s16) ((rand ()) % 8)) - 4 ;
  }

  REG_BG0HOFS = 0 ;
  REG_BG0VOFS = 0 ;
  set_blending_mode (old_blending_mode) ;
}




void horizontal_slide_screen (u16 *src_map, u16 *dest_map, short top_offset,
			      short height)
{
  short x, y, iteration ;

  for (iteration = 0; iteration < 30; iteration++) {
    while (REG_VCOUNT != 160) ;
    for (y = top_offset; y < top_offset + height; y++) {
      if (y % 2 == 0) {
	for (x = 0; x < iteration; x++) {
	  dest_map[ y * (256 / 8) + x] =
	    src_map [((y - top_offset) * 30) + x] ;
	}
      }
      else {
	for (x = 30 - iteration; x < 30; x++) {
	  dest_map[ y * (256 / 8) + x] =
	    src_map [((y - top_offset) * 30) + x] ;
	}
      }        /* fin du else. */
    }          /* Fin du for (y = top_offset; y < top__offset + */
  }            /* Fin de for (iteration = 0; iteration < 30; iteration++) */
}




void blink_key_sprite ()
{
  u16 old_screen_mode ;
  BOOL visible = FALSE ;
  unsigned long previous_elapsed_seconds = 0 ;

  old_screen_mode = REG_DISPCNT ;
  set_screen_mode (old_screen_mode | OBJ_MAP_1D | OBJ_ENABLE) ;
  previous_elapsed_seconds = elapsed_seconds ;

  pointer_sprite.attribute1 = pointer_sprite.attribute1 & 0xFE00 ;
  pointer_sprite.attribute0 = pointer_sprite.attribute0 & 0xFF00 ;
  pointer_sprite.attribute1 = pointer_sprite.attribute1 | 240 ;
  pointer_sprite.attribute0 = pointer_sprite.attribute0 | 160 ;
  memcpy (sprite_video_memory, &pointer_sprite, sizeof (struct sprite)) ;

  start_timer2_as_interrupt () ;
  KEY_POOL ;
  while (!(KEY_HIT (BUTTON_A))) {
    button_sprite.attribute1 = button_sprite.attribute1 & 0xFE00 ;
    button_sprite.attribute0 = button_sprite.attribute0 & 0xFF00 ;
    if (previous_elapsed_seconds < elapsed_seconds) {
      previous_elapsed_seconds = elapsed_seconds ;
      if (visible) {
	button_sprite.attribute1 = button_sprite.attribute1 | BUTTON_SPRITE_X ;
	button_sprite.attribute0 = button_sprite.attribute0 | BUTTON_SPRITE_Y ;
      }
      else {
	button_sprite.attribute1 = button_sprite.attribute1 | 240 ;
	button_sprite.attribute0 = button_sprite.attribute0 | 160 ;
      }
      while (REG_VCOUNT < 160) ;
      memcpy
	(&sprite_video_memory[1], &button_sprite, sizeof (struct sprite)) ;
      visible = !visible ;
      }
    KEY_POOL ;
  }

  stop_timer2_as_interrupt () ;
  button_sprite.attribute1 = button_sprite.attribute1 & 0xFE00 ;
  button_sprite.attribute0 = button_sprite.attribute0 & 0xFF00 ;
  button_sprite.attribute1 = button_sprite.attribute1 | 240 ;
  button_sprite.attribute0 = button_sprite.attribute0 | 160 ;
  while (REG_VCOUNT < 160) ;
  memcpy
    (&sprite_video_memory[1], &button_sprite, sizeof (struct sprite)) ;
  set_screen_mode (old_screen_mode) ;
}
