/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <stdlib.h>
#include <gba.h>
#include <screen_mode.h>
#include "basic_types_defs.h"
#include "game.h"
#include "bg_data.h"
#include "letters_data.h"
#include "popup_data.h"
#include "sfonts_data.h"
#include "progress_data.h"
#include "sprites_data.h"





void reload_game_background_graphics ()
{
  u16 i, j, k ;
  u16 *bg_pal = BACKGROUND_PALETTE_ADDR ;
  u16 *bg_tiles = CHAR_BASE_BLOCK_0_ADDR ;
  u16 *bg_map = SCREEN_BASE_BLOCK_24_ADDR ;
  u16 *wlist_map = SCREEN_BASE_BLOCK_25_ADDR ;
  u16 old_screen_mode ;

  old_screen_mode = REG_DISPCNT ;
  set_screen_mode (0) ;

  /* Fond. */
  set_background0
    (BACKGROUND_PRIORITY_3 |            /* Priorit la plus faible. */
     BACKGROUND_CHAR_BASE_BLOCK_0 |     /* Tiles */
     BACKGROUND_COLOR_256 |             /* 256 couleurs. */
     BACKGROUND_SCREEN_BASE_BLOCK_24 |  /* Map. */
     TEXT_BACKGROUND_256x256) ;         /* 256 x 256 pixels. */

  /* Palette du fond. */
  for (i = 0; i < BG_PALETTE_SIZE; i++)
    bg_pal[i] = background_palette[i] ;

  /* Palette des petites fontes. */
  for (i = 0; i < SFONTS_PALETTE_SIZE; i++)
    bg_pal[i + (WLIST_PALETTE_SLOT * 16)] = sfonts_palette[i] ;

  /* Chargement des tiles du fond d'cran en mmoire. */
  k = 0 ;
  for (i = 0; i < BG_NB_TILES * (64 / 2); i++) {
    bg_tiles[k] =
      (u16) ((background_tiles[(i * 2) + 1]<< 8) |
	     (background_tiles[(i * 2)])) ;
    k++ ;
  }
  /* Chargement des tiles de grandes lettres  la suite. */
  for (i = 0; i < LETTERS_NB_TILES * (64 / 2); i++) {
    bg_tiles[k] =
      (u16) ((letters_tiles[(i * 2) + 1] << 8) | (letters_tiles[(i * 2)])) ;
    k++ ;
  }

  /* Chargement de la map de fond et effacement du tableau de jeu. */
  k = 0 ;
  for (j = 0; j < 20; j++) {          /* Boucle verticale. */
    for (i = 0; i < 30; i++) {        /* Boucle honrizontale. */
      bg_map[(j * (256 / 8)) + i] = (u16) background_map[k] ;
      wlist_map[(j * (256 / 8)) + i] = (u16) (0 | (WLIST_PALETTE_SLOT << 12)) ;
      k++ ;
    }
  }

  REG_BG0HOFS = 0 ; REG_BG0VOFS = 0 ;
  REG_BG1HOFS = 0 ; REG_BG1VOFS = 0 ;
  set_screen_mode (old_screen_mode) ;
}





void init_game_graphics ()
{
  u16 i ;
  u16 *wlist_tiles = CHAR_BASE_BLOCK_1_ADDR ;

  reload_game_background_graphics () ;

  /* Messages. Ils partagent les tiles avec la liste des mots. */
  set_background2
    (BACKGROUND_PRIORITY_1 |            /* Priorit au dessus des mots. */
     BACKGROUND_CHAR_BASE_BLOCK_1 |     /* Tiles */
     BACKGROUND_COLOR_16 |              /* 16 couleurs. */
     BACKGROUND_SCREEN_BASE_BLOCK_26 |  /* Map. */
     TEXT_BACKGROUND_256x256) ;         /* 256 x 256 pixels. */
 
  /* Liste de mots. */
  set_background1
    (BACKGROUND_PRIORITY_2 |            /* Priorit au dessus du fond. */
     BACKGROUND_CHAR_BASE_BLOCK_1 |     /* Tiles */
     BACKGROUND_COLOR_16 |              /* 16 couleurs. */
     BACKGROUND_SCREEN_BASE_BLOCK_25 |  /* Map. */
     TEXT_BACKGROUND_256x256) ;         /* 256 x 256 pixels. */

  /* Chargement des tiles de petites lettres pour les messages. */
  for (i = 0; i < SFONTS_NB_TILES * (32 / 2); i++)
    wlist_tiles[i] =
      (u16) ((sfonts_tiles[(i * 2) + 1] << 8) | (sfonts_tiles[(i * 2)])) ;
  wlist_tiles = &wlist_tiles[i] ;
  /* Chargement des tiles de bord des popups juste derrire. */
  for (i = 0; i < POPUP_NB_TILES * (32 / 2); i++)
    wlist_tiles[i] =
      (u16) ((popup_tiles[(i * 2) + 1] << 8) | (popup_tiles[(i * 2)])) ;
  wlist_tiles = &wlist_tiles[i] ;
  /* Chargement juste derrire des tiles de petites lettres pour la wlist. */
  for (i = 0; i < WLIST_NB_TILES * (32 / 2); i++)
    wlist_tiles[i] =
      (u16) ((wlist_sfonts_tiles[(i * 2) + 1] << 8) |
	     (wlist_sfonts_tiles[(i * 2)])) ;
  wlist_tiles = &wlist_tiles[i] ;
  /* Chargement juste derrire des tiles pour la barre de progression. */
  for (i = 0; i < PROGRESS_NB_TILES * (32 / 2); i++)
    wlist_tiles[i] =
      (u16) ((progress_tiles[(i * 2) + 1] << 8) |
	     (progress_tiles[(i * 2)])) ;

  REG_BG2HOFS = 0 ; REG_BG2VOFS = 0 ;
  set_screen_mode (MODE_0 | BG0_ENABLE | BG1_ENABLE | OBJ_MAP_1D) ;
}





struct sprite pointer_sprite = { 0, 0, 0, 0 } ;
struct sprite button_sprite = { 0, 0, 0, 0 } ;
struct sprite *sprite_video_memory = SPRITES_INFO_MEMORY_ADR ;




void init_sprites_graphics (void)
{
  u16 i, k ;
  u16 *tiles = SPRITES_CHAR_BASE_BLOCK_ADR ;
  u16 *palette = SPRITES_PALETTE_ADR ;

  /* Chargement des tiles des sprites. */
  k = 0 ;
  for (i = 0; i < SPRITES_NB_TILES * (64 / 2) ; i++) {
    tiles[k] =
      (u16) ((sprites_tiles[(i * 2) + 1]<< 8) | (sprites_tiles[(i * 2)])) ;
    k++ ;
  }

  /* Chargement de la palette des sprites. */
  for (i = 0; i < SPRITES_PALETTE_SIZE ; i++)
    palette[i] = sprites_palette[i] ;

  /* Cache tous les sprites en dehors de l'cran pour que */
  /* ceux que l'on n'utilisera pas ne se voient pas.      */
  for (i = 0; i < 128; i++) {
    sprite_video_memory[i].attribute0 = 160 ; /* y vers > 159. */
    sprite_video_memory[i].attribute1 = 240 ; /* x vers  > 239. */
  }

  /* Initialisation du sprite du curseur. */
  pointer_sprite.attribute0 = SPRITE_256_COLOR | SPRITE_SQUARE ;
  pointer_sprite.attribute1 = SPRITE_SIZE_16 ;
  pointer_sprite.attribute2 = POINTER_SPRITE_TILE_INDEX ;

  /* Initialisation du sprite du bouton. */
  button_sprite.attribute0 = SPRITE_256_COLOR | SPRITE_SQUARE ;
  button_sprite.attribute1 = SPRITE_SIZE_16 ;
  button_sprite.attribute2 = BUTTON_SPRITE_TILE_INDEX ;
}





/* Ncessaire pour viter de librer de la mmoire que l'on    */
/* n'aurait pas alloue lors du tout premier lancement du jeu. */
void init_empty_game_structure ()
{
  global_game.possibilities = (struct list_item*) NULL ;
  global_game.submissions_head = (struct list_item*) NULL ;
  global_game.submissions_tail = (struct list_item*) NULL ;
}
