/*
  *** Blabla GBA ***
 Franois PESSAUX Dcember 2004
 This program is freeware.
 Use its sources as you whant provided that you leave this copyright unchanged
 and that you drop a small word telling that I'm the author of these sources.
 Thank's a lot.
   --Francois
*/

#include <gba.h>
#include <screen_mode.h>
#include "basic_types_defs.h"
#include "game.h"
#include "automaton.h"
#include "popup_char_table.h"
#include "popup_data.h"
#include "sfonts_data.h"
#include "printing.h"
#include "key_input.h"
#include "time.h"




const void draw_popup_shape ()
{
  u16 *req_map = SCREEN_BASE_BLOCK_26_ADDR ;
  short line, column, k ;
  
  k = 0 ;
  for (line = 20 - POPUP_HEIGHT ; line < 20 ; line++) {
    for (column = 0; column < 30 ; column++) {
      req_map[(line * (256 / 8)) + column] =
	((popup_map[k] + SFONTS_NB_TILES) | (WLIST_PALETTE_SLOT << 12)) ;
      k++ ;
    }
  }
}





static void do_print_at (const unsigned char *str)
{
  u16 *req_map = SCREEN_BASE_BLOCK_26_ADDR ;
  short line = 20 - POPUP_HEIGHT + 1 ;
  short  column = 2 ;
  short i ;
  u16 c ;

  for (i = 0; str[i] != '\0'; i++) {
    c = (u16) str[i] ;
    /* Scrolling vertical d au dpassement de la taille horizontale. */
    if (column >= 28) {
      column = 2 ;
      line++ ;
    }

    /* Cas du saut de ligne. */
    if (c == '\n') {
      line++ ;
      column = 2 ;
      continue ;
      }

    /* Gestion du scrolling vertical d au */
    /* dpassement de la taille verticale. */
    if (line >= 19) {
      /* On affiche une petite flche dans la bordure. */
      req_map[(19 * (256/8)) + 27] =
	(u16) (SFONTS_DOTDOTDOT_TILE_INDEX | (WLIST_PALETTE_SLOT << 12)) ;
      KEY_POOL ;
      while (! KEY_HIT (BUTTON_A)) { KEY_POOL ; }
      draw_popup_shape () ;
      line = 20 - POPUP_HEIGHT + 1 ;
      column = 2 ;
    }

    /* Correction pour tomber au bon indice dans la table des tiles. */
    c = popup_char_to_tile_table[c] ;
    req_map [(line * (256 / 8)) + column] =
      ((u16) c | (WLIST_PALETTE_SLOT << 12)) ;
    column++ ;
  }
}





BOOL popup_message (BOOL expect_answer, const unsigned char *str)
{
  u8 line, column ;
  u16 old_screen_mode ;
  BOOL ret_code = FALSE ;

  suspend_game_timer () ;
  /* On sauvegarde le mode vido d'origine. */
  old_screen_mode = REG_DISPCNT ;
  draw_popup_shape () ;
  line = 0 ;
  column = 0 ;

  /* On autorise l'affichage du layer de requesters */
  /* et on laisse celui du fond.                    */
  set_screen_mode ((old_screen_mode & (~OBJ_ENABLE)) | BG2_ENABLE) ;

  do_print_at (str) ;

  if (expect_answer == FALSE) {
    /* On attend une pression sur le bouton A ou        */
    /* B indiffremment pour faire disparatre le tout. */
    KEY_POOL ;
    while ((!KEY_HIT (BUTTON_A)) && (!KEY_HIT (BUTTON_B))) { KEY_POOL ; }
    ret_code = FALSE ;
  }
  else {
    for (;;) {
      /* On attend une pression sur le bouton A ou B pour faire */
      /* disparatre le tout et retourner le code adquat.      */
      KEY_POOL ;
      if (KEY_HIT (BUTTON_A)) { ret_code = TRUE ; break ; }
      if (KEY_HIT (BUTTON_B)) { ret_code = FALSE ; break ; }
    }
  }

  /* On restaure le mode vido d'origine. */
  set_screen_mode (old_screen_mode) ;

  KEY_POOL ;
  restart_game_timer () ;
  return (ret_code) ;
}
